const std = @import("std");
const sdl = @import("sdl2");
const gl = @import("zgl");

//const Game = @import("Game.zig");
//const MainMenu = @import("MainMenu.zig");

//const State = @import("flow.zig").State;

pub fn main() !void {
    try sdl.init(.{ .video = true, .audio = true, .events = true });
    defer sdl.quit();

    try sdl.gl.setAttribute(.{ .context_major_version = 2 });
    try sdl.gl.setAttribute(.{ .context_minor_version = 1 });

    const window = try sdl.createWindow(
        "USG",
        .{ .centered = {} },
        .{ .centered = {} },
        1280,
        720,
        .{ .opengl = true, .shown = true }
    );
    defer window.destroy();

    const ctx = try sdl.gl.createContext(window);
    defer sdl.gl.deleteContext(ctx);

    //var renderer = SDL.SDL_CreateRenderer(window, -1, SDL.SDL_RENDERER_PRESENTVSYNC | SDL.SDL_RENDERER_ACCELERATED) orelse return;
    //defer _ = SDL.SDL_DestroyRenderer(renderer);

    //var main_menu = MainMenu.init();
    //var game = Game.init(renderer);

    //var current_state: State = main_menu.state;

    //_ = SDL.SDL_SetRenderDrawBlendMode(renderer, SDL.SDL_BLENDMODE_BLEND);
    //_ = SDL.IMG_Init(SDL.IMG_INIT_JPG);

    mainLoop: while (true) {
        while (sdl.pollEvent()) |ev| {
            switch (ev) {
                .quit => break :mainLoop,
                else => {},
            }
        }

        gl.clear(.{});

        sdl.gl.swapWindow(window);

        //_ = SDL.SDL_SetRenderDrawColor(renderer, 231, 247, 255, 0xFF);
        //_ = SDL.SDL_RenderClear(renderer);

        //current_state = switch (current_state) {
            //.main_menu => main_menu.tick(),
            //.game => game.tick(),
        //};

        //SDL.SDL_RenderPresent(renderer);
    }
}

fn initGL() void {

}
